//+------------------------------------------------------------------+
//|                                                  rsi signals.mq4 |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Red

//
//
//
//
//

extern int    RSIPeriod       = 5;
extern int    RSIPrice        = 0;
extern double levelOs         = 30;
extern double levelOb         = 70;
extern int    arrowsize       = 2;

extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";





//
//
//
//
//

double sigUp[];
double sigDn[];
double rsi[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{

   IndicatorBuffers(4);  
   SetIndexBuffer(0,sigUp); SetIndexStyle(0,DRAW_ARROW,0,arrowsize); SetIndexArrow(0,241);
   SetIndexBuffer(1,sigDn); SetIndexStyle(1,DRAW_ARROW,0,arrowsize); SetIndexArrow(1,242);
   SetIndexBuffer(2,rsi);
   SetIndexBuffer(3,trend);
         
   IndicatorShortName("RSI Signals");
return(0);
}

int deinit()  {   return(0);  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//


int start() 
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
            
   for (i=limit; i>=0; i--)
   {
      rsi[i] = iRsi(iMA(NULL,0,1,0,MODE_SMA,RSIPrice,i),RSIPeriod,i);
      trend[i] = 0;
         if (rsi[i]>levelOb) trend[i] = 1;
         if (rsi[i]<levelOs) trend[i] =-1;
             
         //
         //
         //
         //
         //
             
         sigUp[i] = EMPTY_VALUE;
         sigDn[i] = EMPTY_VALUE;
         if (trend[i]!= trend[i+1])
         {
           if (trend[i+1] ==  1 && trend[i] != 1) sigDn[i] = High[i] + iATR(NULL,0,20,i)/2;
           if (trend[i+1] == -1 && trend[i] !=-1) sigUp[i] =  Low[i] - iATR(NULL,0,20,i)/2;
         }
               
       }
       
       //
       //
       //
       //
       //
          
       if (alertsOn)
       {
         if (alertsOnCurrent)
              int whichBar = 0;
         else     whichBar = 1;
         if (trend[whichBar] != trend[whichBar+1])
         {
            if (trend[whichBar+1] ==  1 && trend[whichBar] != 1) doAlert(whichBar,"sell");
            if (trend[whichBar+1] == -1 && trend[whichBar] !=-1) doAlert(whichBar,"buy");
         }           
   }
return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

double workRsi[][3];
#define _price  0
#define _change 1
#define _changa 2

//
//
//
//

double iRsi(double price, double period, int shift, int forz=0)
{
   if (ArrayRange(workRsi,0)!=Bars) ArrayResize(workRsi,Bars);
      int    z     = forz*3; 
      int    i     = Bars-shift-1;
      double alpha = 1.0/period; 

   //
   //
   //
   //
   //
   
   workRsi[i][_price+z] = price;
   if (i<period)
      {
         int k; double sum = 0; for (k=0; k<period && (i-k-1)>=0; k++) sum += MathAbs(workRsi[i-k][_price+z]-workRsi[i-k-1][_price+z]);
            workRsi[i][_change+z] = (workRsi[i][_price+z]-workRsi[0][_price+z])/MathMax(k,1);
            workRsi[i][_changa+z] =                                         sum/MathMax(k,1);
      }
   else
      {
         double change = workRsi[i][_price+z]-workRsi[i-1][_price+z];
                         workRsi[i][_change+z] = workRsi[i-1][_change+z] + alpha*(        change  - workRsi[i-1][_change+z]);
                         workRsi[i][_changa+z] = workRsi[i-1][_changa+z] + alpha*(MathAbs(change) - workRsi[i-1][_changa+z]);
      }
   if (workRsi[i][_changa+z] != 0)
         return(50.0*(workRsi[i][_change+z]/workRsi[i][_changa+z]+1));
   else  return(0);
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," rsi ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," rsi "),message);
             if (alertsSound)   PlaySound(soundfile);
   }
}
   
   